<template>
  <box :loading="loading">
    <template v-slot:title>Roles List</template>

    <div class="w-full flex flex-row justify-end">
      <lull-button type="info" @click="$router.push('/roles/new')">
        New Role
      </lull-button>
    </div>

    <lull-datatable
      class="w-full"
      v-if="data"
      :loading="loading"
      :data="data.items"
      :pageInfo="data.pageInfo"
      :totalCount="data.totalCount"
      :onNext="onNext"
      :onPrevious="onPrevious"
      @update:filterData="setFilterData"
    >
      <lull-datatableColumn
        id="name"
        label="Name"
        :sortable="true"
        :filterable="true"
      />

      <lull-datatableColumn
        id="description"
        label="Description"
        :sortable="true"
        :filterable="true"
      />

      <lull-datatableColumn
        id="protected"
        label="Protected"
        justifyContent="center"
        :sortable="true"
        :width="'25rem'"
      />

      <lull-datatableColumn id="totalUsers" label="Total Users" />

      <lull-datatableColumn
        :width="'25rem'"
        id="actions"
        justifyContent="center"
      >
        <span></span>
      </lull-datatableColumn>

      <template v-slot:actions="{ row }">
        <lull-button
          class="w-0.5"
          type="danger"
          :disabled="row.protected"
          @click="deleteRole(row.id)"
        >
          <lull-icon icon="fa-trash" />
        </lull-button>

        <lull-button
          class="w-0.5 ml-3"
          type="info"
          :disabled="row.protected"
          @click="$router.push(`/roles/${row.id}`)"
        >
          <lull-icon icon="fa-edit" />
        </lull-button>
      </template>

      <template v-slot:protected="{ row }">
        <lull-icon v-if="row.protected" icon="fa-check" />
        <span v-else />
      </template>
    </lull-datatable>

    <confirm
      v-model="confirmationModal"
      :callback="confirmationCallback"
      message="Are you sure you want to permanently delete this role?"
    />
  </box>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  onBeforeMount,
  onBeforeUnmount,
  ref,
} from 'vue';
import { Confirm } from '@/core/components';
import { DatatableFilterData, useLullToast } from 'lull-ui';
import { RolesModule, RolesAction } from '@/store/Roles';
import { useStore } from '@/store';

export default defineComponent({
  name: 'roles',
  components: {
    confirm: Confirm,
  },
  setup() {
    const store = useStore();
    const filterData = ref<null | DatatableFilterData>(null);
    const loading = computed(() => store.getters['roles/loading']);
    const data = computed(() => store.getters['roles/roles']);
    const confirmationModal = ref<boolean>(false);
    const confirmationCallback = ref<Function | null>(null);
    const confirmationMessage = ref<string | null>(null);
    const toast = useLullToast();

    async function getRoles(): Promise<void> {
      await store.dispatch(`roles/${RolesAction.GetRoles}`, {
        filter: filterData.value,
      });
    }

    async function onNext(cursor: string): Promise<void> {
      await store.dispatch(`users/${RolesAction.GetRoles}`, {
        after: cursor,
        filter: filterData.value,
      });
    }

    async function onPrevious(cursor: string): Promise<void> {
      await store.dispatch(`users/${RolesAction.GetRoles}`, {
        before: cursor,
        filter: filterData.value,
      });
    }

    async function setFilterData(filter: DatatableFilterData): Promise<void> {
      filterData.value = filter;
      await getRoles();
    }

    async function deleteRole(roleId: number) {
      const cb = async (): Promise<void> => {
        const results = await store.dispatch(
          `roles/${RolesAction.DeleteRole}`,
          roleId
        );

        if (results) {
          toast.success({ title: 'Success', message: 'Role deleted.' });
        }
      };

      confirmationCallback.value = cb;
      confirmationModal.value = true;
    }

    onBeforeMount(async () => {
      await store.registerModule('roles', RolesModule);
      await getRoles();
    });

    onBeforeUnmount(async () => {
      await store.unregisterModule('roles');
    });

    return {
      filterData,
      loading,
      data,
      confirmationModal,
      confirmationCallback,
      confirmationMessage,
      onNext,
      onPrevious,
      setFilterData,
      deleteRole,
    };
  },
});
</script>